//---------------------------------------------------------------------------
#ifndef CurrencyFieldH
#define CurrencyFieldH
#include <Db.hpp>
#include "Decimal.h"

//---------------------------------------------------------------------------
class PACKAGE TDecimalField : public Db::TBCDField
{
	typedef Db::TBCDField inherited;

private:
    unsigned int FDecimalPrecision;

protected:
    void   __fastcall SetPrecision(unsigned int APrecision)
    {
        if (APrecision>MAX_PRECISION) throw Exception(" .");
        else FDecimalPrecision=APrecision;
    };
    Currency    __fastcall GetAsCurrency();
    void        __fastcall SetAsCurrency(Currency Value);
    Decimal       __fastcall GetAsDecimal();
    void        __fastcall SetAsDecimal(Decimal Value);
    void        __fastcall GetText(AnsiString &Text, bool DisplayText);
    AnsiString  __fastcall GetAsString(void);

public:
    __fastcall TDecimalField(TComponent* AOwner);
    __property Decimal AsDecimal = {read=GetAsDecimal, write=SetAsDecimal};

__published:
    __property unsigned int Precision = {read=FDecimalPrecision, write=SetPrecision, default=2};

};
#endif
